int DEBUGD = 0; // set to 1 for debug information

// Threads used for the Take from the input buffer (local and global spread versions)
// This thread distribute the data to the workers
void DinputSPlocalthread (int *junky) 
{
  int i, j, s1,s2;
  int shutdowncount = 0;     // How many workers have I told to shutdown
  MPI_Status status;
  int junk, ROOT, worker; 
  callnode_t *parentgroup, *partnergroup;
  int *partnermembers, level;

  if (DEBUGD) printf("Starting DinputSPlocalthread\n");

  // Finding the root
  ROOT = Top - FrStack[Top]->nestlevel + 1;  

  parentgroup = GetMyParentGroup();
  level = parentgroup->level;

  // I consider here a local spread -> send only to the root of the partner.
  worker=0;

  while (shutdowncount < FrStack[Top]->context.d.nw) { 
    
    // first find the processes corresponding to the workers with whom i communicate
    // the son number "worker" of the parentgroup
    partnergroup = parentgroup->acts[worker];
    partnermembers = partnergroup->members[0];

    if (FrStack[ROOT]->bnext < FrStack[ROOT]->inmul) {  
      // send out the next item, all to the worker root
      MPI_Comm_size(FrStack[Top]->context.d.fromfarmercomm,&s1);
      MPI_Comm_size(FrStack[ROOT]->mycomm,&s2);
      if (DEBUGD) printf("*** inputthrSPlocal send data to worker %d, process %d -- %d %d %d\n",
			 worker,partnermembers[level],partnergroup->level,parentgroup->level,Top);

      MPI_Send (&(FrStack[ROOT]->blens[FrStack[ROOT]->bnext]), 1, 
                MPI_INT, partnermembers[level], NOSHUTDOWNTAG, FrStack[Top]->context.d.fromfarmercomm); 

      MPI_Send (FrStack[ROOT]->buff[FrStack[ROOT]->bnext], 
                FrStack[ROOT]->blens[FrStack[ROOT]->bnext],
                FrStack[Top]->inty, 
                partnermembers[level], NOSHUTDOWNTAG, FrStack[Top]->context.d.fromfarmercomm); 

      FrStack[ROOT]->bnext++;
    } else {
      // send the SHUTDOWNTAG to the worker root only
      if (DEBUGD) printf("... inputthrSPlocal: no more data - send shutdown to %d \n", worker);
      MPI_Send (&junk, 1, MPI_INT, partnermembers[level], SHUTDOWNTAG, FrStack[Top]->context.d.fromfarmercomm);
      shutdowncount++;
    }
    // send data to the next worker
    worker = (worker+1)%FrStack[Top]->context.d.nw;
  }
}


// The same for global spread
void DinputSPglobalthread (int *junky) 
{
  int i, j, s1,s2;
  int shutdowncount = 0;     // How many workers have I told to shutdown
  MPI_Status status;
  int junk, ROOT, worker; 
  callnode_t *parentgroup, *partnergroup;
  int *partnermembers, *mymembers, *partnerranks;
  int level, partnersize;

  if (DEBUGD) printf("Starting DinputSPglobalthread\n");

  // Finding the root
  ROOT = Top - FrStack[Top]->nestlevel + 1;  

  parentgroup = GetMyParentGroup();
  level = parentgroup->level;

  worker=0;

  while (shutdowncount < FrStack[Top]->context.d.nw) { 
    
    // first find the processes corresponding to the worker with whom i communicate
    // the son number "worker" of the parentgroup
    partnergroup = parentgroup->acts[worker];
    partnersize  = partnergroup->actsz[0];
    partnermembers = partnergroup->members[0];
    mymembers = GetMyGroup()->members[0];
    partnerranks = (int *) malloc(sizeof(int)*partnersize);

    if (FrStack[ROOT]->bnext < FrStack[ROOT]->inmul) {  
      // send out the next item, all to the worker root
      MPI_Comm_size(FrStack[Top]->context.d.fromfarmercomm,&s1);
      MPI_Comm_size(FrStack[ROOT]->mycomm,&s2);
      
      for (i=0; i<partnersize; i++) {
	partnerranks[i] = partnermembers[i*(partnergroup->level+1)+level];

	if (DEBUGD) printf("*** i=%d *** inputthr send data to worker %d, process %d %d\n",
			   i,worker,partnermembers[i*(partnergroup->level+1)+level],
			   partnerranks[i]);
	
	MPI_Send (NULL, 0, MPI_INT, partnerranks[i],
		  NOSHUTDOWNTAG, FrStack[Top]->context.d.fromfarmercomm); 
       
      }

      MPI_Comm_size(FrStack[Top]->context.d.fromfarmercomm,&s1);
      MPI_Comm_rank(FrStack[Top]->context.d.fromfarmercomm,&s2);

      group2group (FrStack[Top]->context.d.fromfarmercomm, s1, s2,
		   SENDER,  FrStack[Top]->myrank,
                   FrStack[Top]->mycomm,  FrStack[Top]->mycommsize,
		   mymembers, MPI_COMM_NULL, partnersize, partnerranks,
                   FrStack[Top]->outty, FrStack[Top]->outitemsz,
		   FrStack[ROOT]->buff[FrStack[ROOT]->bnext], 
		   FrStack[ROOT]->blens[FrStack[ROOT]->bnext],
		   NULL, NULL);
      
      FrStack[ROOT]->bnext++;
    } else {
      // send the SHUTDOWNTAG to the worker root only
      if (DEBUGD) printf("... inputthrSPglobal: no more data - send shutdown to %d \n", worker);

      for (i=0; i<partnersize; i++) {
	partnerranks[i] = partnermembers[i*(partnergroup->level+1)+level];
	MPI_Send (&junk, 1, MPI_INT, partnerranks[i],
		  SHUTDOWNTAG, FrStack[Top]->context.d.fromfarmercomm);
      }
      shutdowncount++;
    }
    
    worker = (worker+1)%FrStack[Top]->context.d.nw;
  }
}




// Threads used for the Give to the output buffer (local and global spread versions)
// This thread collect the data from the workers and copy it into the buffer
// *** NOT WORKING YET IN THIS VERSION ***
void outputthr (int *junky) 
{
  int i, j;
  int shutdowncount = 0;     // How many workers have I told to shutdown 
  MPI_Status status;
  int junk, ROOT, worker;

  ROOT = Top - FrStack[Top]->nestlevel + 1;  

  printf("Starting outputthr, but not implemented yet \n");
  exit(0);
}


// Called with SPLOCAL data
// only the root of the first stage calls this, taking all the SPLOCAL data down from the skeleton
void DrecvSPlocalthread (int *junk)
{
  int i, j, ROOT;
  int totalrecvlen;
  char **tempbuff;
  int *lenscount;
  char *cpptr;
  callnode_t *inbuffgroup;
  int *inbuffrootranks;   // ranks of the inbuff group processes as they are in the root comm

  // Finding the root
  ROOT = Top - FrStack[Top]->nestlevel + 1;  

  inbuffgroup = InBuffGroup(FrStack[Top]->mycalltree);
  inbuffrootranks = (int *) malloc (sizeof(int)*inbuffgroup->actsz[0]);
  for (i=0; i<inbuffgroup->actsz[0]; i++)
    inbuffrootranks[i] = inbuffgroup->members[0][i*(inbuffgroup->level+1)];

  lenscount = (int *) malloc (sizeof (int));
  tempbuff   = (char **) malloc (sizeof(char *));

  *lenscount = -1;
  group2group (FrStack[ROOT]->allcomm1, FrStack[ROOT]->parentcommsize,
               FrStack[ROOT]->parentcommrank, RECEIVER,  FrStack[ROOT]->parentcommrank,
               FrStack[ROOT]->allcomm2,  FrStack[ROOT]->parentcommsize, 
               FrStack[ROOT]->allranks,
               FrStack[Top]->stagerootonlycomm,
	       1, inbuffrootranks, MPI_INT, mpiintsize, NULL, 0,
	       (char **) &FrStack[ROOT]->blens, lenscount);
  
  // count and recv the data with g2g
  for (totalrecvlen=0, i=0; i<*lenscount; i++)
    totalrecvlen += FrStack[ROOT]->blens[i];

  *tempbuff = (char *) malloc (totalrecvlen*FrStack[Top]->context.p.itemsz[0]);
  group2group (FrStack[ROOT]->allcomm1, FrStack[ROOT]->parentcommsize,
               FrStack[ROOT]->parentcommrank, RECEIVER,  FrStack[ROOT]->parentcommrank,
               FrStack[ROOT]->allcomm2,  FrStack[ROOT]->parentcommsize, 
               FrStack[ROOT]->allranks,
               FrStack[Top]->stagerootonlycomm,
	       1, inbuffrootranks, FrStack[Top]->context.p.ty[0],
	       FrStack[Top]->context.p.itemsz[0], 
               NULL, 0, tempbuff, &totalrecvlen);

  // set up the buff itself, by copying for now, although could just set pointers into tempbuff?
  FrStack[ROOT]->buff = (char **) malloc (sizeof(char *) * (*lenscount));
  cpptr = *tempbuff;
  for (i=0; i<*lenscount; i++) {
    (FrStack[ROOT]->buff)[i] = 
       (char *) malloc ( (FrStack[ROOT]->blens)[i] * FrStack[Top]->context.p.itemsz[0]);
    memcpy ((void *) (FrStack[ROOT]->buff)[i], (void *) cpptr,
            (FrStack[ROOT]->blens)[i] * FrStack[Top]->context.p.itemsz[0]);
    cpptr += FrStack[ROOT]->blens[i]*FrStack[Top]->context.p.itemsz[0];
  }

  FrStack[ROOT]->inmul = *lenscount; // set new effective inmul for root
  FrStack[ROOT]->bnext = 0;          // set up "pointer" for Take       
  
  /*
  if (DEBUGD)
    for (i=0; i<*lenscount;i++) {
      printf("****  blens[%d]=%d \n",i,FrStack[ROOT]->blens[i]);
      for (j=0;j<FrStack[ROOT]->blens[i];j++) {
	printf(" buff %d \n",((int *) FrStack[ROOT]->buff[i])[j]);
      }
    }
  */
}


// Called with SPGLOBAL data
// all processes of the first stage active, taking an SPGLOBAL datum down from the skeleton
void DrecvSPglobalthread (int *inmul)
{
  int i,j;
  int ROOT; // Frame stack index for the root call of this hierarchy
  int *len;
  char **tmpbuff;
  callnode_t *inbuffgroup;
  int *inbuffrootranks;   // ranks of the inbuff group processes as they are in the root comm

  // Finding the root
  ROOT = Top - FrStack[Top]->nestlevel + 1;  

  inbuffgroup = InBuffGroup(FrStack[Top]->mycalltree);
  inbuffrootranks = (int *) malloc (sizeof(int)*inbuffgroup->actsz[0]);
  for (i=0; i<inbuffgroup->actsz[0]; i++)
    inbuffrootranks[i] = inbuffgroup->members[0][i*(inbuffgroup->level+1)];
 
  len = (int *) malloc (sizeof (int));
  tmpbuff  = (char **) malloc (sizeof(char *) * (*inmul)); 

  for (i=0; i<*inmul; i++) {
    *len = -1;
    group2group (FrStack[ROOT]->allcomm1, FrStack[ROOT]->parentcommsize,
                 FrStack[ROOT]->parentcommrank, RECEIVER,  FrStack[ROOT]->myrank,
                 FrStack[ROOT]->allcomm2,  FrStack[ROOT]->parentcommsize, 
                 FrStack[ROOT]->allranks,
                 FrStack[Top]->mycomm,
		 FrStack[Top]->mycommsize,
		 inbuffrootranks,
                 FrStack[Top]->inty,
		 FrStack[Top]->initemsz,
                 NULL, 0, tmpbuff, len);
    FrStack[ROOT]->blens[i] = *len;
    FrStack[ROOT]->buff[i] = (char *) malloc (sizeof(int) * (*len));
    memcpy((int *) FrStack[ROOT]->buff[i], (int *) *tmpbuff, sizeof(int) * (*len));
    
    /*
    if (DEBUGP) {
      printf("****  blens[%d]=%d - malloc %d  %d\n",i,FrStack[ROOT]->blens[i], sizeof(int) * (*len), sizeof(tmpbuff));
    for (j=0;j<*len;j++) {
      //((int *) FrStack[Top]->buff[i])[j] = ((int *) tmpbuff[0])[j];
      printf(" buff %d \n",((int *) FrStack[ROOT]->buff[i])[j]);
    }
    }
    */
  }
}



// Called once, immediately after construction of the call tree, to 
// copy the input buffer data from the root group to the appropriate
// (hierarchy specific) leaf group
void DealBuildInputBuffer (void) {
  int i,totalsendlen;
  int ROOT;     // frame stack index for the root call of this hierarchy
  callnode_t *inbuffgroup;
  int *inbuffrootranks;   // ranks of the inbuff group processes as they are in the root comm
  char *sndptr;
  pthread_t recvthread;
  void *threadval;

  // Top is the actual level of nesting, and nestlevel indicates where to go back to find
  //   the buffer. We need to add 1 since the info for the first level is 1   
  ROOT = Top - FrStack[Top]->nestlevel + 1;  

  if (DEBUGD) printf("DealBuildInputBuffer, rank = %d, col = %d, Top = %d, level = %d, ROOT = %d \n",FrStack[Top]->myrank, FrStack[Top]->mycol, Top, FrStack[Top]->nestlevel, ROOT);

  inbuffgroup = InBuffGroup(FrStack[Top]->mycalltree);
  inbuffrootranks = (int *) malloc (sizeof(int)*inbuffgroup->actsz[0]);
  for (i=0; i<inbuffgroup->actsz[0]; i++)
    inbuffrootranks[i] = inbuffgroup->members[0][i*(inbuffgroup->level+1)];

  
  //--------------------gathering global spread data-------------------------------//
  if (FrStack[ROOT]->inbufspr == SPGLOBAL) {

    sndptr = (char *) FrStack[ROOT]->in;

    if (inbuffgroup == GetMyGroup()) { // I will hold the assembled input buffer, so make it
      FrStack[ROOT]->blens = (int *)  malloc (sizeof(int)*FrStack[ROOT]->inmul);
      FrStack[ROOT]->buff  = (char **)malloc (sizeof(char *)*FrStack[ROOT]->inmul);

      // and spark receiver threads on input buffer processes
      pthread_create(&recvthread, NULL, (void* (*)(void *))&DrecvSPglobalthread, &FrStack[ROOT]->inmul);
    }

     // Now the "senders" loop calling group2group
    for (i=0; i<FrStack[ROOT]->inmul; i++) {
      group2group (FrStack[ROOT]->allcomm1, FrStack[ROOT]->parentcommsize,
		   FrStack[ROOT]->parentcommrank, SENDER,  FrStack[ROOT]->parentcommrank,
		   FrStack[ROOT]->allcomm2,  FrStack[ROOT]->parentcommsize, 
		   FrStack[ROOT]->allranks,
		   (MPI_Comm) NULL, inbuffgroup->actsz[0], inbuffrootranks,
		   FrStack[ROOT]->inty, FrStack[ROOT]->initemsz,
		   sndptr, FrStack[ROOT]->inlens[i], NULL, NULL);
      sndptr = sndptr + (FrStack[ROOT]->initemsz * FrStack[ROOT]->inlens[i]);
    }
    FrStack[ROOT]->bnext = 0; // set up "pointer" for Take

    if (inbuffgroup == GetMyGroup())
      pthread_join(recvthread, &threadval);
  }


  //--------------------gathering local spread data-------------------------------//
  else {

    // spark receiver thread on in buffer group root
    if (inbuffgroup == GetMyGroup() && FrStack[Top]->myrank == 0) {
      pthread_create(&recvthread, NULL, (void* (*)(void *))&recvSPlocalthread, NULL);
    }
    // send the lengths with a g2g
    group2group (FrStack[ROOT]->allcomm1, FrStack[ROOT]->parentcommsize,
                 FrStack[ROOT]->parentcommrank, SENDER,  FrStack[ROOT]->parentcommrank,
                 FrStack[ROOT]->allcomm2,  FrStack[ROOT]->parentcommsize, FrStack[ROOT]->allranks,
                 (MPI_Comm) NULL, 1, inbuffrootranks,  // actually only the first will be used
                 MPI_INT, mpiintsize,
		 (char *) FrStack[ROOT]->inlens, FrStack[ROOT]->inmul, NULL, NULL);
    
    // count and send the data with g2g
    for (totalsendlen=0, i=0; i<FrStack[ROOT]->inmul; i++) {
      totalsendlen += FrStack[ROOT]->inlens[i];
    }

    group2group (FrStack[ROOT]->allcomm1, FrStack[ROOT]->parentcommsize,
                 FrStack[ROOT]->parentcommrank, SENDER,  FrStack[ROOT]->parentcommrank,
                 FrStack[ROOT]->allcomm2,  FrStack[ROOT]->parentcommsize, 
                 FrStack[ROOT]->allranks,
                 (MPI_Comm) NULL, 1, inbuffrootranks,
                 FrStack[ROOT]->inty, FrStack[ROOT]->initemsz, 
                 FrStack[ROOT]->in, totalsendlen, NULL, NULL);
    
    if (inbuffgroup == GetMyGroup() && FrStack[Top]->myrank == 0)
      pthread_join(recvthread, &threadval);

  }

  if (DEBUGD) printf("End DealBuildInputBuffer - %d %d \n", FrStack[ROOT]->mycol, FrStack[ROOT]->myrank);  
}



// all processes of the final stage active, sending an SPGLOBAL result back up to the skeleton
// Called by ReturnOutputBuffer
void dealsendthread (int *outmul) {
  int i;
  callnode_t *outbuffgroup;
  int *outbuffrootranks;
  int ROOT;

  // Top is the actual level of nesting, and nestlevel indicates where to go back to find
  // the buffer. We need to add 1 since the info for the first level is 1  
  ROOT = Top - FrStack[Top]->nestlevel + 1;  

  // Looking at the group holding the output buffer (last stage group)
  outbuffgroup = OutBuffGroup(FrStack[Top]->mycalltree,ROOT);
  outbuffrootranks = (int *) malloc (sizeof(int) * outbuffgroup->actsz[0]);
  for (i=0; i<outbuffgroup->actsz[0]; i++)
    outbuffrootranks[i] = outbuffgroup->members[0][i*(outbuffgroup->level+1)];

  for (i=0; i<*outmul; i++) {
    group2group (FrStack[ROOT]->allcomm1, FrStack[ROOT]->parentcommsize,
		 FrStack[ROOT]->parentcommrank, SENDER,  FrStack[Top]->myrank,
		 FrStack[Top]->mycomm,  FrStack[Top]->mycommsize,  
		 outbuffrootranks,
		 FrStack[ROOT]->allcomm2, FrStack[ROOT]->parentcommsize, 
		 FrStack[ROOT]->allranks,
		 FrStack[ROOT]->outty, 
		 FrStack[ROOT]->outitemsz,
		 FrStack[ROOT]->poutbuff[i], FrStack[ROOT]->poutblens[i], NULL, NULL);
  }
}


// Called once, immediately after construction of the call tree,
// to make the temporary output buffer in the appropriate
// (hierarchy specific) leaf group
// Need to handle unknown number of outputs                 
void DealBuildOutputBuffer (void) {
  int i, ROOT;
  callnode_t *outbuffgroup;
  int *outbuffrootranks;    // ranks of the outbuff group processes as they are in the root comm

  // Top is the actual level of nesting, and nestlevel indicates where to go back to find
  // the buffer. We need to add 1 since the info for the first level is 1      
  ROOT = Top - FrStack[Top]->nestlevel + 1;  

  // Looking at the group holding the output buffer (last stage group)
  outbuffgroup = OutBuffGroup(FrStack[Top]->mycalltree,ROOT);
  outbuffrootranks = (int *) malloc (sizeof(int) * outbuffgroup->actsz[0]);
  for (i=0; i<outbuffgroup->actsz[0]; i++)
    outbuffrootranks[i] = outbuffgroup->members[0][i*(outbuffgroup->level+1)];
  
  // Processes of outbuffrootranks: create output buffers
  if (outbuffgroup == GetMyGroup()) {
    // Global spread: data distributed between all processes working on the last stage
    if (FrStack[ROOT]->outbufspr == SPGLOBAL) {
      FrStack[ROOT]->poutblens = (int *)   malloc (sizeof(int)*MAXOUTMUL);
      FrStack[ROOT]->poutbuff  = (char **) malloc (sizeof(char *)*MAXOUTMUL);
      FrStack[ROOT]->poutbnext = 0;
    }
    else { 
      // Local spread: everything will be on the process root of the outbuffgroup.
      if (FrStack[ROOT]->parentcommrank == outbuffrootranks[0]) {
        FrStack[ROOT]->poutblens = (int *)  malloc (sizeof(int)*MAXOUTMUL);
        FrStack[ROOT]->poutbuff  = (char **)malloc (sizeof(char *)*MAXOUTMUL);
        FrStack[ROOT]->poutbnext = 0;
      }
    }
  }

  return;
}



// Called once, immediately after termination of the leaf
// activities in a hierarchy, to copy the output
// buffer data from the leaves to the hierarchy root group
void DealReturnOutputBuffer (void) {

  int i,temp, ROOT;
  callnode_t *outbuffgroup;
  int *outbuffrootranks;    // ranks of the outbuff group processes as they are in the root comm
  int outbuffspaceleft;     // during output, how much space is left in the out buffer    
  int outbufflensspaceleft; // during output, how much space is left in the outlens buffer
  char *rcvptr;
  pthread_t sendthread;
  void *threadval;      
  int *tempptr;
  char **rcvptrptr;

  // Top is the actual level of nesting, and nestlevel indicates where to go back to find
  // the buffer. We need to add 1 since the info for the first level is 1      
  ROOT = Top - FrStack[Top]->nestlevel + 1;  

  if (DEBUGD)
    printf("*** Returning output buffer for Deal... Top %d ROOT %d stage %d rank %d\n", Top, ROOT, FrStack[ROOT]->mycol,FrStack[ROOT]->myrank);

  // Looking at the group holding the output buffer (last stage group)
  outbuffgroup = OutBuffGroup(FrStack[Top]->mycalltree,ROOT);
  outbuffrootranks = (int *) malloc (sizeof(int) * outbuffgroup->actsz[0]);
  for (i=0; i<outbuffgroup->actsz[0]; i++)
    outbuffrootranks[i] = outbuffgroup->members[0][i*(outbuffgroup->level+1)];
  
  
  // Distribute output from buffer at final stage
  
  // -------------------------- DealReturnOutputBuffer for SPGLOBAL --------------------------//
  if (FrStack[ROOT]->outbufspr == SPGLOBAL) {

    //if (DEBUGD) printf("DealReturnOutputBuffer - SPGLOBAL\n");

    outbuffspaceleft     = FrStack[ROOT]->outbuffsz;
    outbufflensspaceleft = FrStack[ROOT]->outlenP[0][1]; 

    // broadcast actual multiplicity of output
    MPI_Bcast(&FrStack[ROOT]->poutbnext, 1, MPI_INT,
	      outbuffrootranks[0], // root of the last stage
	      FrStack[ROOT]->parentcomm);
    
    FrStack[ROOT]->blens = (int *)  malloc (sizeof(int)* FrStack[ROOT]->poutbnext);
    rcvptr = (char *) FrStack[ROOT]->out;

    // Now the "receivers" loop calling group2group
    // spark sender threads on stage ns-1 processes
    
    if (outbuffgroup == GetMyGroup())
      pthread_create(&sendthread, NULL, (void* (*)(void *))&dealsendthread, &(FrStack[ROOT]->poutbnext));
 
    tempptr = (int *) malloc(sizeof(int));
    rcvptrptr = (char **) malloc(sizeof(char *));
    for  (i=0; i<FrStack[ROOT]->poutbnext; i++) {
      *rcvptrptr = rcvptr;
      *tempptr = outbuffspaceleft;

      group2group (FrStack[ROOT]->allcomm1, FrStack[ROOT]->parentcommsize,
		   FrStack[ROOT]->parentcommrank, RECEIVER,  FrStack[ROOT]->parentcommrank,
		   FrStack[ROOT]->mycomm,  FrStack[ROOT]->mycommsize,  
		   outbuffrootranks, // array with the last stage processes
		   FrStack[ROOT]->allcomm2, FrStack[ROOT]->parentcommsize, 
		   FrStack[ROOT]->allranks,
		   FrStack[ROOT]->outty,
		   FrStack[ROOT]->outitemsz,
		   NULL, 0, rcvptrptr, tempptr); 
      outbuffspaceleft -= *tempptr;
      if (i<outbufflensspaceleft) {
	FrStack[ROOT]->outlenP[0][i] = *tempptr;
      } else {
        fprintf(stderr, "No more space for pipeline outbufflens\n");
	exit(0);
      } 
      rcvptr += ((*tempptr)*FrStack[ROOT]->outitemsz);
    } 
    if (outbuffgroup == GetMyGroup()) { 
      pthread_join(sendthread, &threadval);
    }
    **(FrStack[ROOT]->outmulP) = FrStack[ROOT]->poutbnext;
  } 

  // ----------------- DealReturnOutputBuffer for SPLOCAL -------------------------//
  else {    // distribute local spread results
    // It would be "neat" to do this with g2g as well, but it just doesn't fit because of the 
    // possibility of varying item length in pipelinev. If the data length is uniform, eg as 
    // in pipeline, then it would fit.                                                       
    
    //if (DEBUGD) printf("  *** DealReturnOutputBuffer for local spread - %d \n", FrStack[0]->myrank);
    
    Local_Mult_Scatter (FrStack[ROOT]->parentcomm, FrStack[ROOT]->parentcommsize,
			FrStack[ROOT]->parentcommrank,
			outbuffrootranks[0], FrStack[Top]->outty,
			FrStack[Top]->outitemsz,
			(void **) FrStack[ROOT]->poutbuff , FrStack[ROOT]->poutbnext, 
			FrStack[ROOT]->poutblens, (char *) FrStack[ROOT]->out,
			FrStack[ROOT]->outmulP[0], FrStack[ROOT]->outlenP[0]);
  }  
  
  if (DEBUGD) printf("End DealReturnOutBuff %d \n", FrStack[0]->myrank);
  return;
}





void DealGive (void *out[], int len[]) {
  int i, j;
  int mylevel, mysize, *mymembers;
  int partnerlevel, partnersize, *partnermembers;
  MPI_Status stat;
  int junk, ROOT, **lenptr;
  callnode_t *mynode, *partnernode, *partnerfather, *outbufgroup;
  
  // Top is the actual level of nesting, and nestlevel indicates where to go back to find
  // the buffer. We need to add 1 since the info for the first level is 1
  ROOT = Top - FrStack[Top]->nestlevel + 1;  
  
  if (DEBUGD)
    printf("DEALGIVE - Top %d, rank %d, col %d - ROOT %d, rank %d, col %d\n",
	   Top, FrStack[Top]->myrank, FrStack[Top]->mycol, ROOT,
	   FrStack[ROOT]->myrank, FrStack[ROOT]->mycol);

  if (FrStack[Top]->mycalltree == NULL) {
    // This must be the first interaction, so build the call tree
    BuildCallTree();

    // Print the call tree for debugging purposes
    if (DEBUGD) if ((FrStack[ROOT]->myrank == 0)&&(FrStack[ROOT]->mycol == 0))
      DisplayCallTree(FrStack[Top]->mycalltree);

    // and then copy down the input buffer from the root of this call hierarchy,
    DealBuildInputBuffer();    
    
    // and allocate space for the output buffer.
    DealBuildOutputBuffer();

  }

  // Now get on with the Take
  mynode = GetMyGroup();
  mylevel = mynode->level;
  mysize  = mynode->actsz[0];
  mymembers = mynode->members[0];

  if (DEBUGD) {
  printf("Group:  || ");
  for (i=0; i<mysize; i++) {
    for (j=0; j<mylevel+1; j++) {
      printf("%d ",mymembers[i*(mylevel+1) + j]);
    }
    printf("|| ");
  }
  printf(" giving to Take Group:  || ");
  }

  partnernode = GetTakeGroup(mynode, FrStack[Top]->mycalltree, FrStack[Top]->nbgive);
  FrStack[Top]->nbgive += 1;
  partnerlevel = partnernode->level;
  partnersize  = partnernode->actsz[0];
  partnermembers = partnernode->members[0]; 

  if (DEBUGD) {
  if (partnermembers) {
    for (i=0; i<partnersize; i++) {
      for (j=0; j<partnerlevel+1; j++) {
        printf("%d ",partnermembers[i*(partnerlevel+1) + j]);
      }
      printf("|| ");
    }
    printf("\n");
  } else {
    printf("unknown group ||\n");
  }
  }

  // The outbuf node, used several times
  outbufgroup = OutBuffGroup(FrStack[Top]->mycalltree, ROOT);

  //------------------------------------------ Give SPGLOBAL --------------------------------------/
  if (FrStack[Top]->context.d.outspr == SPGLOBAL) {
    
    if (outbufgroup == partnernode) {
      // This worker is part of a Deal creating the output buffer
      // Send the result to the outputthread (send shutdowntag as well)

      printf("*** DealGive communicates with outputthread, not implemented yet\n");
      exit(0);

      if (DEBUGD) printf("DealGive-SPGLOBAL: to outbuf\n");
      FrStack[ROOT]->poutblens[FrStack[ROOT]->poutbnext] = len[0];
      FrStack[ROOT]->poutbuff[FrStack[ROOT]->poutbnext] =
        (char *) malloc (len[0]*FrStack[Top]->outitemsz);
      
      //printf("size of memcpy: %d * %d  \n", mylen, FrStack[Top]->context.p.itemsz[FrStack[Top]->mycol+1]);
      memcpy((void *) FrStack[ROOT]->poutbuff[FrStack[ROOT]->poutbnext],
	     (char *) out[0], len[0]*FrStack[Top]->outitemsz);
      FrStack[ROOT]->poutbnext++;
    }
    else { 
      // Interact with next stage

      if (len[0] == SHUTDOWNLEN) {
	// pass on the shutdown message
	if (DEBUGD) printf("DealGive-SPGLOBAL: shutdown message\n");
	if (FrStack[Top]->myrank == 0) {
	  for (i=0; i<partnersize; i++) {
	    MPI_Send(NULL, 0, MPI_INT,
		     partnermembers[i*(partnerlevel+1)], 
		     SHUTDOWNTAG, FrStack[ROOT]->parentcomm);
	  }
	}
	
	// If the partner is a Deal, needs to go on passing the shutdowntag through
	// standard Give. Need to add another tag to confirm end of shutdown
	partnerfather = ((FrStack[Top]->mycalltree)->acts[FrStack[ Top - (mynode->level - (FrStack[Top]->mycalltree)->level - 1) ]->mycol + 1]);
	
	if ((FrStack[Top]->context.d.shutdown != ENDSHUTDOWN) && (partnerfather->skel == Dskel)) {
	  FrStack[Top]->context.d.shutdown = ENDSHUTDOWN;
	  for (i=0; i<partnerfather->Nacts-1; i++)
	    DealGive(out,len);
	}	
	
	DealReturnOutputBuffer();
	return;
      }
      
      // No shutdown tag => first indicate that this is a real transfer
      if (DEBUGD) printf("DealGive-SPGLOBAL: interact with next stage\n");

      if (FrStack[Top]->myrank == 0) {
        for (i=0; i<partnersize; i++) {
	  MPI_Send(NULL, 0, MPI_INT,
		   partnermembers[i*(partnerlevel+1)], 
		   NOSHUTDOWNTAG, FrStack[ROOT]->parentcomm);
	}
      }
      
      // and then send the stuff
      group2group (FrStack[ROOT]->parentcomm, FrStack[ROOT]->parentcommsize,
                   FrStack[ROOT]->parentcommrank, SENDER,  FrStack[Top]->myrank,
                   FrStack[Top]->mycomm,  FrStack[Top]->mycommsize,
		   mymembers, MPI_COMM_NULL, partnersize, partnermembers,
                   FrStack[Top]->outty, FrStack[Top]->outitemsz,
                   (char *) out[0], len[0], NULL, NULL);
    }
  }
  
  //------------------------------------------ Give SPLOCAL --------------------------------------/
  else if (FrStack[Top]->context.d.outspr == SPLOCAL) {

    if (FrStack[Top]->myrank == 0) {  // I am the root of the stage
      if (len[0] == SHUTDOWNLEN) {
	if (DEBUGD) printf("Give-SPLOCAL: the root of the stage pass on the shutdown message\n");
        // pass on the shutdown message
        MPI_Send(NULL, 0,  FrStack[Top]->context.p.ty[FrStack[Top]->mycol+1],
                 partnermembers[0], SHUTDOWNTAG, FrStack[ROOT]->parentcomm);
	// and build the output buffer
	DealReturnOutputBuffer();
        return;
      }

      if (mynode == partnernode) {
	if (DEBUGD) printf("Give-SPLOCAL: last stage write into buffer\n");
        // last stage so buffer it until later
        FrStack[ROOT]->poutblens[FrStack[ROOT]->poutbnext] = len[0];
        FrStack[ROOT]->poutbuff[FrStack[ROOT]->poutbnext] =
          (char *) malloc (len[0]*FrStack[Top]->context.p.itemsz[FrStack[Top]->mycol+1]);
        memcpy((void *) FrStack[ROOT]->poutbuff[FrStack[ROOT]->poutbnext],
               (char *) out[0], len[0]*FrStack[Top]->context.p.itemsz[FrStack[Top]->mycol+1]);
        FrStack[ROOT]->poutbnext++;
      } else {
        // Send the item from the root of this stage to the root of the next, via the parent comm
	if (DEBUGD)
	  printf("Give-SPLOCAL gives %d data to %d \n", len[0], partnermembers[0]);
        MPI_Send((char *) out[0], len[0],  FrStack[Top]->context.p.ty[FrStack[Top]->mycol+1],
                 partnermembers[0], NOSHUTDOWNTAG,  FrStack[ROOT]->parentcomm);
      }
    }
    else {
      // I'm not the root but still need to perform the ReturnOutputBuffer if needed
      if (len[0] == SHUTDOWNLEN) {
	DealReturnOutputBuffer();
	return;
      }
    }
  }  
  return;
}


void **DealTake (int **len) {
  int i, j, s1, s2;
  int mylevel, mysize, *mymembers;
  int partnerlevel, partnersize, *partnermembers, *partnerranks;
  callnode_t *mynode, *partnernode, *myfather;
  int ROOT;
  MPI_Status stat;
  int junk;
  void **takeptr2;
  pthread_t inputthread, outputthread;
  int level;
  
  // Top is the actual level of nesting, and nestlevel indicates where to go back to find
  // the buffer. We need to add 1 since the info for the first level is 1
  ROOT = Top - FrStack[Top]->nestlevel + 1;  
  
  if (DEBUGD)
    printf("DEALTAKE - Top %d, rank %d, col %d - ROOT %d, rank %d, col %d\n",
		     Top, FrStack[Top]->myrank, FrStack[Top]->mycol, ROOT,
		     FrStack[ROOT]->myrank, FrStack[ROOT]->mycol);
  
  if (FrStack[Top]->mycalltree == NULL) {
    // This must be the first interaction, so build the call tree
    BuildCallTree();

    // Print the call tree for debugging purposes
    if (DEBUGD) if ((FrStack[ROOT]->myrank == 0)&&(FrStack[ROOT]->mycol == 0))
      DisplayCallTree(FrStack[Top]->mycalltree);
    
    // and then copy down the input buffer from the root of this call hierarchy,
    DealBuildInputBuffer();

    // and allocate space for the output buffer.
    DealBuildOutputBuffer();

    // If InBuffGroup is in the Deal, need to create a thread to distribute the data
    // to the different workers
    if (GetMyGroup()==InBuffGroup(FrStack[Top]->mycalltree)) {
      if (DEBUGD) printf("Creating input thread\n");
      if ((FrStack[Top]->context.d.inspr == SPLOCAL) && (FrStack[Top]->mycol ==0))
	pthread_create(&inputthread, NULL,  (void* (*) (void *))&DinputSPlocalthread, NULL);
      else if (FrStack[Top]->context.d.inspr == SPGLOBAL)
	pthread_create(&inputthread, NULL, (void* (*) (void *))&DinputSPglobalthread, NULL);
    }
    
    // If OutBuffGroup is in the Deal, need to create a thread to collect the data
    // from the different workers
    if (GetMyGroup()==OutBuffGroup(FrStack[Top]->mycalltree,ROOT)) {
      if (DEBUGD) printf("Creating output thread\n");
      // create the thread on all processes for SPGLOBAL, only p0 for SPLOCAL
      // *** need to define different threads
      if (!((FrStack[Top]->context.d.outspr == SPLOCAL) && (FrStack[Top]->mycol !=0)))
	pthread_create(&outputthread, NULL,  (void* (*) (void *))&outputthr, NULL);
    }
  }

  // Now get on with the Give
  mynode = GetMyGroup();
  mylevel = mynode->level;
  mysize  = mynode->actsz[0];
  mymembers = mynode->members[0];

  if (DEBUGD) {
  printf("Group:  || ");
  for (i=0; i<mysize; i++) {
    for (j=0; j<mylevel+1; j++) {
      printf("%d ",mymembers[i*(mylevel+1) + j]);
    }
    printf("|| ");
  }
  printf(" taking from Give Group:  || ");
  }

  partnernode = GetGiveGroup(mynode, FrStack[Top]->mycalltree, FrStack[Top]->nbtake);
  FrStack[Top]->nbtake += 1;
  partnerlevel = partnernode->level;
  partnersize  = partnernode->actsz[0];
  partnermembers = partnernode->members[0]; 

  if (DEBUGD) {
  if (partnermembers) {
    for (i=0; i<partnersize; i++) {
      for (j=0; j<partnerlevel+1; j++) {
        printf("%d ",partnermembers[i*(partnerlevel+1) + j]);
      }
      printf("|| ");
    }
    printf("\n");
  } else {
    printf("unknown group ||\n");
  }
  }
  
  myfather = GetMyParentGroup();
  level = myfather->level;
  partnerranks = (int *) malloc(sizeof(int)*partnersize);
  for (i=0; i<partnersize; i++)
    partnerranks[i]= partnermembers[i*(partnerlevel+1)+level];


  //--------------------- Take SPGLOBAL ---------------------------------------//
  if (FrStack[Top]->context.d.inspr == SPGLOBAL) {
    if (FrStack[Top]->context.d.shutdown) {
      printf("Trying to Take after shutdown....\n");
      exit(0);
    }

    // If I'm in the input buffer group, I need to communicate with the inputthread
    // which distribute the data between workers
    if (myfather->acts[0] == partnernode) {
      
	if (DEBUGD) printf("DealTake-SPGLOBAL: Communicate with the inputthread \n");

	*len = (int *) malloc (sizeof(int));
	MPI_Recv(&junk, 1, MPI_INT, partnerranks[0], MPI_ANY_TAG,
		 FrStack[Top]->context.d.fromfarmercomm, &stat);

	if (stat.MPI_TAG==SHUTDOWNTAG) {
	  if (DEBUGD)
	    printf("DealTake-SPGLOBAL: process %d find shutdown tag\n", FrStack[ROOT-1]->myrank);
	  FrStack[Top]->context.d.shutdown = TRUE;
	  // Special case where it's also the last stage: should build the output buffer
	  if (myfather->acts[0] == OutBuffGroup(FrStack[Top]->mycalltree,ROOT))
	    DealReturnOutputBuffer();
	  return NULL;
	}
	
	if (DEBUGD)
	  printf("DealTake-SPGLOBAL: first stage find non empty buffer \n");
	
	takeptr2 = (void **) malloc (sizeof(void *));
	*takeptr2 = (void *) malloc (FrStack[Top]->initemsz * (**len)); 
	i=-1;
	**len = i;
	
	MPI_Comm_size(FrStack[Top]->context.d.fromfarmercomm,&s1);
	MPI_Comm_rank(FrStack[Top]->context.d.fromfarmercomm,&s2);
	group2group (FrStack[Top]->context.d.fromfarmercomm, s1, s2,
		     RECEIVER,  FrStack[Top]->myrank,
		     MPI_COMM_NULL,  partnersize, partnerranks,
		     FrStack[Top]->mycomm, FrStack[Top]->mycommsize,
		     mymembers,
		     FrStack[Top]->inty,
		     FrStack[Top]->initemsz,
		     NULL, 0, (char **) takeptr2, *len);
	// if (DEBUGD) printf("Take-SPGLOBAL: found length %d and data %d %d\n", *len[0], ((int *) takeptr)[0], 0);
	
	return takeptr2;
    }
    
    //-------- Take SPGLOBAL, not the input buffer group ------------//
    else {
      // other stage so interact with previous stage
       MPI_Recv(&junk, 1, MPI_INT, partnermembers[0], MPI_ANY_TAG, FrStack[ROOT]->parentcomm, &stat);
       if (stat.MPI_TAG==SHUTDOWNTAG) {
	if (DEBUGD)
	  printf("DealTake-SPGLOBAL: process %d find shutdown tag\n", FrStack[ROOT-1]->myrank);
	FrStack[Top]->context.d.shutdown = TRUE;
	
	// Send the shutdowntag to the other workers?
	// Build the output buffer if it is the very last stage
	// This means not necessarily OutBuffGroup but all workers of the last stage
	// If the first worker in my node is OutBuffGroup :-)
	if (myfather->acts[0] == OutBuffGroup(FrStack[Top]->mycalltree,ROOT))
	  DealReturnOutputBuffer();
	return NULL;
      }
      // get the stuff
      if (DEBUGD) printf("DealTake-SPGLOBAL: interact with previous stage\n");
      takeptr2 = (void **) malloc (sizeof(void *));
      *len = (int *) malloc (sizeof(int));
      i=-1;
      **len = i;
      
      group2group (FrStack[ROOT]->parentcomm, FrStack[ROOT]->parentcommsize,
		   FrStack[ROOT]->parentcommrank, RECEIVER,  FrStack[Top]->myrank,
		   MPI_COMM_NULL,  partnersize,
		   partnermembers,
		   FrStack[Top]->mycomm, FrStack[Top]->mycommsize,
		   mymembers,
		   FrStack[Top]->inty,
		   FrStack[Top]->initemsz,
		   NULL, 0, (char **) takeptr2, *len);
      // if (DEBUGD) printf("Take-SPGLOBAL: found length %d and data %d %d\n", *len[0], ((int *) takeptr)[0], 0);
      return takeptr2;
    }
  }

 
  //--------------------- Take SPLOCAL ---------------------------------------//
  else if (FrStack[Top]->context.d.inspr == SPLOCAL) {    
    
    if (FrStack[Top]->myrank == 0) {
      
      // Part of the input buffer
      if (myfather->acts[0] == partnernode) {
	
	if (DEBUGD) printf("DealTake-SPLOCAL: Communicate with the inputthread \n");

	*len = (int *) malloc (sizeof(int));
	MPI_Recv(*len, 1, MPI_INT, partnermembers[level], MPI_ANY_TAG,
		 FrStack[Top]->context.d.fromfarmercomm, &stat);
	
	if (stat.MPI_TAG==SHUTDOWNTAG) {
	  if (DEBUGD) printf("DealTake-SPLOCAL: process %d find shutdown tag\n", FrStack[ROOT-1]->myrank);
	  junk = SHUTDOWNTAG;
	  MPI_Bcast(&junk, 1, MPI_INT, 0, FrStack[Top]->mycomm);
	  FrStack[Top]->context.d.shutdown = TRUE;
	  // Special case where it's also the last stage: should build the output buffer
	  if (myfather->acts[0] == OutBuffGroup(FrStack[Top]->mycalltree,ROOT))
	    DealReturnOutputBuffer();
	  return NULL;
	}
	
	if (DEBUGD) printf("DealTake-SPLOCAL: first stage find non empty buffer \n");
	
	takeptr2 = (void **) malloc (sizeof(void *));
	*takeptr2 = (void *) malloc (FrStack[Top]->initemsz * (**len)); 
	MPI_Recv(*takeptr2, **len, FrStack[Top]->inty, partnermembers[level], MPI_ANY_TAG,
		 FrStack[Top]->context.d.fromfarmercomm, &stat);
	if (DEBUGD) printf("... DealTake received data \n");
	
	// Broadcast noshutdowntag to other processes
	junk = NOSHUTDOWNTAG;
	MPI_Bcast(&junk, 1, MPI_INT, 0, FrStack[Top]->mycomm);

	return takeptr2;
      }
      else {// Root of another stage
	// Receive data from the preceding root
	if (DEBUGD) printf("Take-SPLOCAL: root of stage %d interact with previous stage \n",
			   FrStack[Top]->mycol + 1);

	*len = (int *) malloc (sizeof(int));
	
	MPI_Probe(MPI_ANY_SOURCE, MPI_ANY_TAG, FrStack[ROOT]->parentcomm, &stat);
	
	if (stat.MPI_TAG==SHUTDOWNTAG) {
	  if (DEBUGD) printf("Take-SPLOCAL find shutdowntag\n");
	  // receive the "message"
	  takeptr2 = (void **) malloc (sizeof(void *));
	  *takeptr2 = (void *) malloc (FrStack[Top]->context.p.itemsz[FrStack[Top]->mycol]);  // dummy
	  MPI_Recv(takeptr2, 1, FrStack[Top]->context.p.ty[FrStack[Top]->mycol],
		   MPI_ANY_SOURCE, MPI_ANY_TAG, FrStack[ROOT]->parentcomm, &stat);
	  // broadcast shutdown tag to other stage members
	  junk = SHUTDOWNTAG;
	  MPI_Bcast (&junk, 1, MPI_INT, 0, FrStack[Top]->mycomm);
	  FrStack[Top]->context.p.shutdown = TRUE;
	  // Build the output buffer if it is the very last stage
	  if (mynode == OutBuffGroup(FrStack[Top]->mycalltree,ROOT))
	    DealReturnOutputBuffer();
	  return NULL;
	}
	else {
	  if (DEBUGD) printf("Take-SPLOCAL find no shutdowntag  \n" );
	  MPI_Get_count(&stat, FrStack[Top]->context.p.ty[FrStack[Top]->mycol], *len);
	  takeptr2 = (void **) malloc (sizeof(void *));
	  *takeptr2 = (void *) malloc (FrStack[Top]->context.p.itemsz[FrStack[Top]->mycol] * (*len[0]));

	  MPI_Recv(*takeptr2, **len, FrStack[Top]->context.p.ty[FrStack[Top]->mycol],
		   MPI_ANY_SOURCE, MPI_ANY_TAG, FrStack[ROOT]->parentcomm, &stat);
	  junk = NOSHUTDOWNTAG;
	  MPI_Bcast (&junk, 1, MPI_INT, 0, FrStack[Top]->mycomm);

	  return takeptr2;
	}	
      }
    }
    else {
      // I'm not the root
      if (DEBUGD) printf("--------- Take-SPLOCAL: i'm not the root\n");

      MPI_Bcast (&junk, 1, MPI_INT, 0, FrStack[Top]->mycomm);
      if (junk==SHUTDOWNTAG) {
	FrStack[Top]->context.p.shutdown = TRUE;
	// output buffer if I am the really last stage
	if (mynode == OutBuffGroup(FrStack[Top]->mycalltree,ROOT))
	  DealReturnOutputBuffer();
	return NULL;
      } else {
	takeptr2 = (void **) malloc (sizeof(void *));    
	*takeptr2 = (void *) malloc (sizeof(void *));
	return takeptr2;
      }      
    }
  }  
  return NULL;
}
